<?php

namespace App\Http\Livewire;

use Livewire\Component;

class CourseDuration extends Component
{
    public $records, $name, $duration, $enabled, $dataId, $update = false, $add = false;

    protected $rules = [
        'name' => 'required',
        'duration' => 'required'
    ];

    protected $messages = [
        'name.required' => 'Il nome è obbligatorio',
        'duration.required' => 'La durata è obbligatoria',
    ];

    public $sortField ='name';
    public $sortAsc = true;

    public function mount(){

        if(\Auth::user()->level != env('LEVEL_ADMIN', 0))
            return redirect()->to('/dashboard');

    }

    public function sortBy($field)
    {
        if($this->sortField === $field)
        {
            $this->sortAsc = ! $this->sortAsc;
        } else {
            $this->sortAsc = true;
        }

        $this->sortField = $field;
    }

    public function resetFields(){
        $this->name = '';
        $this->duration = 0;
        $this->enabled = true;
        $this->emit('load-data-table');
    }

    public function render()
    {
        $this->records = \App\Models\CourseDuration::select('id', 'name', 'duration', 'enabled')->get();
        return view('livewire.course_duration');
    }

    public function add()
    {
        $this->resetFields();
        $this->add = true;
        $this->update = false;
    }

    public function store()
    {
        $this->validate();
        try {
            \App\Models\CourseDuration::create([
                'name' => $this->name,
                'duration' => $this->duration,
                'enabled' => $this->enabled
            ]);
            session()->flash('success','Dato creato');
            $this->resetFields();
            $this->add = false;
        } catch (\Exception $ex) {
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }

    public function edit($id){
        try {
            $course_duration = \App\Models\CourseDuration::findOrFail($id);
            if( !$course_duration) {
                session()->flash('error','Dato non trovato');
            } else {
                $this->name = $course_duration->name;
                $this->duration = $course_duration->duration;
                $this->enabled = $course_duration->enabled;
                $this->dataId = $course_duration->id;
                $this->update = true;
                $this->add = false;
            }
        } catch (\Exception $ex) {
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }

    public function update()
    {
        $this->validate();
        try {
            \App\Models\CourseDuration::whereId($this->dataId)->update([
                'name' => $this->name,
                'duration' => $this->duration,
                'enabled' => $this->enabled
            ]);
            session()->flash('success','Dato aggiornato');
            $this->resetFields();
            $this->update = false;
        } catch (\Exception $ex) {
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }

    public function cancel()
    {
        $this->add = false;
        $this->update = false;
        $this->resetFields();
    }

    public function delete($id)
    {
        try{
            \App\Models\CourseDuration::find($id)->delete();
            session()->flash('success',"Dato eliminato");
            return redirect(request()->header('Referer'));
        }catch(\Exception $e){
            session()->flash('error','Errore (' . $ex->getMessage() . ')');
        }
    }
}
